/* 
 * format (ñ) Ѵ
 * shige
 * 01/12 2004
 * 
 * $Id: sndform.c,v 1.1 2004-01-13 12:23:11+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

int main(int argc,char *argv[]);
int cpSNDheaderTrans(SNDheader *osnd,SNDheader *isnd,int oformat,int iformat);
int put1SNDheaderTrans(FILE *outfile,SNDheader *snd,int iformat,int oformat);
int SNDreadput1chdataTrans(FILE *infile,FILE *outfile,SNDheader *snd,
                           int iformat,int oformat);
int getarg(int argc,char **argv,int *Oformat,FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    int iformat,oformat,ch,bs;
    long int blocks;
    int j,k,ret;

    if((ret=getarg(argc,argv,&oformat,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((iformat=getSNDheader(infile,&snd))<0 || iformat==E_UNKNOWN){
        fprintf(stderr,"get header error.\n");
        return 3;
    }
    put1SNDheaderTrans(outfile,&snd,iformat,oformat);    
    ch=SNDchannels(&snd,iformat);
    blocks=SNDblocks(&snd,iformat);
    bs=SNDblocksize(&snd,iformat);
    for(j=1;j<=blocks;j++)
      for(k=1;k<=ch;k++) 
	SNDreadput1chdataTrans(infile,outfile,&snd,iformat,oformat);
    if(oformat!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

/* ʲ 3 Ĥ common.c Ԥ */
int cpSNDheaderTrans(SNDheader *osnd,SNDheader *isnd,int oformat,int iformat)
{
    if((iformat!=E_AU && iformat!=E_WAV && iformat!=E_AIFF)
       ||(oformat!=E_AU && oformat!=E_WAV && oformat!=E_AIFF)) return -1;
    else if(iformat==oformat){
	cpSNDheader(osnd,isnd,iformat);
	return 1;
    }
    else if(oformat==E_AU){
	(osnd->au).magic=sto4bytei(".snd");
	(osnd->au).fmcode=1; 
        /* linear (2,3,..) ˤƤ⤤ɡषʤñ */
	(osnd->au).smplrate=(long int)(SNDsmplrate(isnd,iformat)+0.5);
	(osnd->au).channel=SNDchannels(isnd,iformat);
	(osnd->au).datalen=SNDblocks(isnd,iformat)*(osnd->au).channel;
	/* bitpersmple ϶Ū 8 ˤ */
	/* (osnd->au.{str,heln}  put header ǤϻȤʤ */
	(osnd->au).str=NULL;
	(osnd->au).hlen=32;
    }
    else if(oformat==E_WAV){
	(osnd->wav).fmcode=1;
	(osnd->wav).channel=SNDchannels(isnd,iformat);
	(osnd->wav).smplrate=(long int)(SNDsmplrate(isnd,iformat)+0.5);
	(osnd->wav).blocksize=SNDblocksize(isnd,iformat);
	(osnd->wav).bytepersec=(osnd->wav).blocksize*(osnd->wav).smplrate;
	(osnd->wav).bitpersmpl=SNDbitpersmpl(isnd,iformat);
	(osnd->wav).datalen=SNDblocks(isnd,iformat)*(osnd->wav).blocksize;
	/* (osnd->wav).hlen  put header ǤϻȤʤ */
	(osnd->wav).hlen=44;
    }
    else{ /* oformat==E_AIFF */
	(osnd->aiff).channel=SNDchannels(isnd,iformat);
	(osnd->aiff).flames=SNDblocks(isnd,iformat);
	(osnd->aiff).bitpersmpl=SNDbitpersmpl(isnd,iformat);
	(osnd->aiff).flamesize=SNDblocksize(isnd,iformat);;
	/* (osnd->aiff).{hlen,datalen}  put header ǤϻȤʤ */
	ConvertToIeeeExtended(SNDsmplrate(isnd,iformat),(osnd->aiff).smplrate.s);
	(osnd->aiff).datalen=(osnd->aiff).flames*(osnd->aiff).flamesize;
	(osnd->aiff).hlen=44+IEEEExtendedBytes;
    }
    return 1;
}

int put1SNDheaderTrans(FILE *outfile,SNDheader *snd,int iformat,int oformat)
{
    SNDheader osnd;
    if((iformat!=E_AU && iformat!=E_WAV && iformat!=E_AIFF)
       ||(oformat!=E_AU && oformat!=E_WAV && oformat!=E_AIFF)) return -1;
    else if(iformat==oformat){
	put1SNDheader(outfile,snd,iformat); 
	return 1;
    }
    else{
	cpSNDheaderTrans(&osnd,snd,oformat,iformat);
	put1SNDheader(outfile,&osnd,oformat);
	return 0;
    }
}

int SNDreadput1chdataTrans(FILE *infile,FILE *outfile,SNDheader *snd,
			   int iformat,int oformat)
{
    SNDheader osnd;

    if((iformat!=E_AU && iformat!=E_WAV && iformat!=E_AIFF)
       ||(oformat!=E_AU && oformat!=E_WAV && oformat!=E_AIFF)) return -1;
    else if(iformat==oformat){
	SNDreadput1chdata(infile,outfile,snd,iformat);
	return 1;
    }
    else{
	cpSNDheaderTrans(&osnd,snd,oformat,iformat);
	SNDput1chleveldata(outfile,
			   SNDget1chleveldata(infile,snd,iformat),
			   &osnd,oformat);
	return 0;
    }
}

int getarg(int argc,char **argv,int *Oformat,FILE **infile,FILE **outfile)
{
    *outfile=stdout;
    *infile=stdin;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc<1 || argc>2){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    if(!strcmp(*argv,"au")){ *Oformat=E_AU; }  
    else if(!strcmp(*argv,"wav")){ *Oformat=E_WAV; }  
    else if(!strcmp(*argv,"aiff")){ *Oformat=E_AIFF; }
    else return -8;
    if(--argc<1 || !strcmp(*argv,"-") ||(*infile=fopen(*argv,"r"))!=NULL)
      return 1;
    else{
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndform (-o [outfile]) [format] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [infile]: ϥե (ά: ɸ)",
	"   [format]: au/wav/aiff",
	" ",
	" [1] ϥեϡ̵ꡢ뤤 '-' ꤷɸ",
	"     Ϥˤʤ롣",
	" [2] ϥեΥǡꤷΤˤ롣",
	" [3] WAV/AIFF -> AU Ѵξ硢Υǡ¿ channel ǡ (",
	"     ƥ쥪) ʤСϤ AU ǡ¿ channel ǡ ˤʤ",
	"     ¿ channel  AU ǡ yomi ΥġǤϥݡȤʤ",
	"     ǡξ sndform  sndmix -nmc  1 channel ǡ ",
	"     (Υ) ˤƤȤ褤",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
