/* ȿñ㲻ġ
 * shige
 * 02/02 2004
 * sndhz.c
 *
 * $Id: sndhz.c,v 1.1 2004-02-05 21:29:15+09 shige Exp $
 */
/* sndhz ([option]) [] [Ĺ]
 * [option]:
 *   -au/wav/aiff: format (default: au)
 *   -ch [n]: channel
 *   -sr [n]: sampling rate
 *   -b [n]: bit length
 *   -v [n]: volume
 *   -o [file]: output file
 *   -wc [s]: ȷ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "common.h"

#define Maxbuff 8192
#define Minhz 15.0
#define Maxhz 100000.0
#define Maxchannels 8
#define Minsmplrate 100
#define Maxsmplrate 200000

#define Default_volume 0.7
#define Default_basepitch 440.0

#define Default_AU_ch 1
#define Default_WAV_ch 1
#define Default_AIFF_ch 1
#define Default_AU_smpl 8000
#define Default_WAV_smpl 11025
#define Default_AIFF_smpl 11025
#define Default_AU_bit 8 /* fix */
#define Default_WAV_bit 16
#define Default_AIFF_bit 16

int main(int argc,char *argv[]);
double per0(double x);
double per1(double x);
double per2(double x);
double genehzfunc(int type,double hz,double t);
void puthzdata(FILE *outfile,SNDheader *snd,int format,double vol,int type,
               double hz);
double gethz(char c1,char c2,int oct,double base);
int setsndheader(SNDheader *Snd,int oform,int ch,int smpl,int bit,char *lenstr);
int getarg(int argc,char **argv,SNDheader *Snd,int *oform,double *vol,
           int *type,double *hz,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *outfile;
    SNDheader snd;
    double vol,hz;
    int type,ret,format;
    
    if((ret=getarg(argc,argv,&snd,&format,&vol,&type,&hz,&outfile))<=0){
	usage(ret); return -ret;
    }
    putallSNDheader(outfile,&snd,1,format);
    puthzdata(outfile,&snd,format,vol,type,hz);
    return 0;
}

/*  1,  -1.0~1.0
 */
double per0(double x)
{
    return sin(2.0*M_PI*x);
}

double per1(double x)
{
    int j;

    j=x;
    return 2.0*(x-j)-1.0;
}

double per2(double x)
{
    int j;

    j=x;
    return (x-j<0.5)?(-1.0):1.0;
}

double genehzfunc(int type,double hz,double t)
{
    switch(type){
    case 0: return per0(hz*t);
    case 1: return per1(hz*t);
    case 2: return per2(hz*t);
    default: return 0.0;
    }
}

void puthzdata(FILE *outfile,SNDheader *snd,int format,double vol,int type,
	       double hz)
{
    long int blocks,j;
    int ch,k,bs;
    double x,smpl;

    ch=SNDchannels(snd,format);
    bs=SNDblocksize(snd,format);
    if((blocks=SNDblocks(snd,format))<=0
       ||(smpl=SNDsmplrate(snd,format))<=0) return;
    for(j=0;j<blocks;j++){
	x=vol*genehzfunc(type,hz,j/smpl);
	for(k=1;k<=ch;k++) SNDput1chleveldata(outfile,x,snd,format);
    }
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return;
}

/* 椯椯ϡΧԥ饹⥵ݡȤ
 */
double gethz(char c1,char c2,int oct,double base)
{
    /* ʿΧܿ */
    double mean[12];
    int tr[]={9,11,0,2,4,5,7},d,j;
    double x;

#ifdef DEBUG1
    fprintf(stderr,"(c1,c2,oct,base)=(%c,%c,%d,%f)\n",c1,c2,oct,base);
#endif
    if(c1<'A' || c1>'G') return -1.0;
    if(c2!=0 && c2!='#' && c2!='b') return -2.0;
    mean[0]=1.0;
    for(j=1;j<12;j++) mean[j]=pow(2.0,(double)j/12.0);

    d=tr[c1-'A'];
    if(c2=='#'){
	if(++d>=12){ oct++; d-=12; }
    }
    else if(c2=='b'){
	if(--d<0){ oct--; d+=12; }
    }
    x=base*mean[d]/mean[9];
    if(oct<0) for(;oct<0;oct++) x/=2.0;
    else if(oct>0) for(;oct>0;oct--) x*=2.0;
    if(x<Minhz || x>Maxhz) return -3.0;
    else return x;
}

int setsndheader(SNDheader *Snd,int oform,int ch,int smpl,int bit,char *lenstr)
{
    double len;
    char buff[Maxbuff];
    long int blocksize;
    int j;

    switch(oform){
    case E_AU:
	(Snd->au).channel=(ch<0)?Default_AU_ch:ch;
	(Snd->au).smplrate=(smpl<0)?Default_AU_smpl:smpl;
	(Snd->au).magic=sto4bytei(".snd");
	(Snd->au).fmcode=1;
	(Snd->au).hlen=32;
	(Snd->au).str=NULL;
	break;
    case E_WAV:
	(Snd->wav).channel=(ch<0)?Default_WAV_ch:ch;
	(Snd->wav).smplrate=(smpl<0)?Default_WAV_smpl:smpl;
	(Snd->wav).bitpersmpl=(bit<0)?Default_WAV_bit:bit;
	(Snd->wav).blocksize=(Snd->wav).channel*(Snd->wav).bitpersmpl/8;
	(Snd->wav).bytepersec=(Snd->wav).blocksize*(Snd->wav).smplrate;
	(Snd->wav).fmcode=1;
	(Snd->wav).hlen=44;
	break;
    case E_AIFF:
	(Snd->aiff).channel=(ch<0)?Default_AIFF_ch:ch;
	(Snd->aiff).bitpersmpl=(bit<0)?Default_AIFF_bit:bit;
	(Snd->aiff).hlen=44+IEEEExtendedBytes;
	ConvertToIeeeExtended((smpl<0)?Default_AIFF_smpl:smpl,
			      (Snd->aiff).smplrate.s);
	(Snd->aiff).flamesize=(Snd->aiff).channel*(Snd->aiff).bitpersmpl/8;
	break;
    default: return -1;
    }
    if((j=strlen(lenstr))<=0 || j>=Maxbuff) return 0;
    strcpy(buff,lenstr);
    if(buff[j-1]=='b'){ /* block */
	buff[j-1]='0';
	if((blocksize=atoi(lenstr))<=0) return -2;
    }
    else{
	if((len=atof(lenstr))<=0.0) return -3;
	blocksize=len*SNDsmplrate(Snd,oform)/1000;
    }
    switch(oform){
    case E_AU: 
	(Snd->au).datalen=blocksize*(Snd->au).channel; 
	break;
    case E_WAV: 
	(Snd->wav).datalen=blocksize*(Snd->wav).blocksize;
	break;
    case E_AIFF: 
	(Snd->aiff).flames=blocksize;
	(Snd->aiff).datalen=blocksize*(Snd->aiff).flamesize;
	break;
    }
    return 0;
}

int getarg(int argc,char **argv,SNDheader *Snd,int *oform,double *vol,
	   int *type,double *hz,FILE **outfile)
{
    char *TypeStr[]={"sin","saw","rect",NULL};
    int j,oct;
    char c1,c2;
    double basep=Default_basepitch;
    int ch=-1,smpl=-1,bit=-1,ret;

    *outfile=stdout;
    *vol=Default_volume;
    *type=0;
    *oform=E_AU;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case 'c':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((ch=atoi(*argv))<=0 || ch>=Maxchannels){
		    fprintf(stderr,"Not correct c value (%s).\n",*argv);
		    return -10;
		}
		break;
	    case 's':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((smpl=atoi(*argv))<=Minsmplrate || smpl>=Maxsmplrate){
		    fprintf(stderr,"Not correct s value (%s).\n",*argv);
		    return -11;
		}
		break;
	    case 'b':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((bit=atoi(*argv))!=8 && bit!=16){
		    fprintf(stderr,"Not correct b value (%s).\n",*argv);
		    return -12;
		}
		break;
	    case 'v':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*vol=atof(*argv))<-1.0 || *vol>1.0){
		    fprintf(stderr,"Not correct v value (%s).\n",*argv);
		    return -12;
		}
		break;
	    case 'p':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((basep=atof(*argv))<=0.0){
		    fprintf(stderr,"Not correct p value (%s).\n",*argv);
		    return -15;
		}
		break;
	    case 't':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(isdigit(**argv)){
		    if((*type=**argv-'0')<0){
			fprintf(stderr,"Not correct t value (%s).\n",*argv);
			return -13;
		    }
		}
		else{
		    for(j=1;TypeStr[j-1]!=NULL;j++)
		      if(!strcmp(*argv,TypeStr[j-1])){ *type=j-1; break; }
		    if(TypeStr[j-1]==NULL){
			fprintf(stderr,"Not correct t value (%s).\n",*argv);
			return -13;
		    } 
		}
		break;
	    case 'a':
	    case 'w':
		if(!strcmp(*argv,"au")) *oform=E_AU;
		else if(!strcmp(*argv,"wav")) *oform=E_WAV;
		else if(!strcmp(*argv,"aiff")) *oform=E_AIFF;
		else{
		    fprintf(stderr,"Unknown option (%s)\n",*argv);
		    return -14;
		}
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc!=2){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    /* #####  ##### */
    if(isdigit(**argv)){
	if((*hz=atof(*argv))<Minhz || *hz>Maxhz){
	    fprintf(stderr,"Not correct hz value (%s)\n",*argv);
	    return -8;
	}
    }
    else{
	if((c1=**argv)<'A' ||c1>'G'){
	    fprintf(stderr,"Not correct hz name (%s)\n",*argv);
	    return -8;
	}
	if(*(++*argv)=='\0'){ oct=0; c2=0; }
	else{
	    if((c2=**argv)=='#' || c2=='b') ++*argv;
	    else c2=0;
	    if(**argv=='\0') oct=0;
	    else oct=atoi(*argv);
	}
	if((*hz=gethz(c1,c2,oct,basep))<=0.0){
	    fprintf(stderr,"Not correct hz name\n");
	    return -9;
	}
    }
    
    /* ##### Ĺ ##### */
    ++argv;
    if((ret=setsndheader(Snd,*oform,ch,smpl,bit,*argv))<0) return ret-20;
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndhz ([option]) [height] [length]",
	"  [height]:  (ȿ or ̾)",
	"  [length]: Ĺ (ߥ or ֥åĹ)",
	"  [option]:",
	"    -au/wav/aiff: ǡ (default: AU)",
	"    -c[n]: channel ",
	"    -s[n]: ץ󥰼ȿ",
	"    -b[n]: ̻Ҳӥåȿ (8 or 16)",
	"    -v[n]: ܥ塼 (-1.0~1.0; default: 0.7)",
	"    -t[s]: ȷ (default: )",
	"    -o[file]: ϥեλ (default: ɸ)",
	"    -p[n]: ܥԥå (A0 μȿ; default 440Hz)",
	" ",
	" [1] ϥե '-' ꤷ硢ޤϲꤷʤ",
	"     ɸϤˤʤ롣",
	" [2] ϡȿ (μ¿)ޤϲ̾ǻꤹ롣̾",
	"       [ե٥å](#|b)([])",
	"     ηǻꤹ롣줾졢",
	"       [ե٥å]: C (),D(),E(),F(ե),G(),A(),B()",
	"       #: Ⱦ夲롢b: Ⱦ (ά)",
	"       []: ֻ (,...,-3,-2,-1,0,1,2,3,...; ά)",
	"     ֿ̣礭⤤֤̣ά",
	"      0 Ȥ롣㤨СF#2, Cb, D-1 Τ褦˻ꤹ롣",
	"     ƲȼȿδطϡC0~C1 Ǥϰʲ̤ (A0=440Hz ξ)",
	"       C0: 261.6256Hz, C#0(=Db0): 277.1826Hz,",
	"       D0: 293.6648Hz, D#0(=Eb0): 311.1270Hz,",
	"       E0: 329.6276Hz,",
	"       F0: 349.2282Hz, F#0(=Gb0): 369.9944Hz",
	"       G0: 391.9954Hz, G#0(=Ab0): 415.3047Hz,",
	"       A0: 440.0000Hz, A#0(=Bb0): 466.1638Hz,",
	"       B0: 493.8833Hz,",
	"       C1: 523.2511Hz,",
	"       (ʿΧ)",
	"      1 ־夬 ()  2  (Ⱦʬ) ˤʤ롣",
	" [3] ̾ϡCb1=B0, B#0=C1, E#0=F0, Fb0=E0 Ȥ롣",
	" [4] ץ󥰼ȿΥǥեȤοͤϡǡ˰ۤʤ롣",
	"           | channel| sampling| bit ",
	"       ----+--------+---------+-------",
	"       AU  |  1ch   |  8000Hz |  8bit ",
	"       WAV |  2ch   | 11025Hz | 16bit ",
	"       AIFF|  2ch   | 11025Hz | 16bit ",
	" [5] ȷϡߤϼΤΤѰդƤ (ޤ̾)",
	"       -t0/-tsin :  (default)",
	"       -t1/-tsaw : Υ (||)",
	"       -t2/-trect:  (||||)",
	" [6] Ĺϡñʤͤξϥߥä򡢿ͤκǸ 'b' ",
	"      block Ḷ́롣λϤ벻Ĺ",
	"     (block Ĺ)/(ץ󥰼ȿ) [] Ȥʤ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
