/*
 * ʣβ file  stereo file 
 * shige
 * 12/29 2003
 * 
 * $Id: sndstereo.c,v 1.5 2004-01-13 15:37:39+09 shige Exp $
 *
 * sndstereo (-o [outf]) [file1] [file2] (...)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

#define Maxchannel 10

int main(int argc,char *argv[]);
void putstereo(FILE *outfile,FILE *infile[],SNDheader snd[],int N,int format);
int maxblocks(int blocks[],int N);
int getallheader(FILE *infile[],SNDheader *snd,int *maxblocks,int N);
void putout1chdata(FILE *outfile,FILE *infile,SNDheader *snd,int format,int ch);
int getarg(int argc,char *argv[],FILE **outfile,FILE *file[]);
void usage(int ret);

int main(int argc,char *argv[])
{
    SNDheader snd[Maxchannel];
    FILE *infile[Maxchannel],*outfile=stdout;
    int N,format,maxblocks;

    if((N=getarg(argc,argv,&outfile,infile))<=0){ usage(N); return -N; }
    if((format=getallheader(infile,snd,&maxblocks,N))<0){ 
	usage(N); return -N; 
    }
    putSNDheaderBlocksChannels(outfile,snd,maxblocks,N,format);
    putstereo(outfile,infile,snd,N,format);
    return 0;
}

void putstereo(FILE *outfile,FILE *infile[],SNDheader snd[],int N,int format)
{
    int j,k,blocks[N],mb,bs;

    for(k=1;k<=N;k++) blocks[k-1]=SNDblocks(&snd[k-1],format);
    mb=maxblocks(blocks,N);

    for(j=1;j<=mb;j++)
      for(k=1;k<=N;k++)
	if(blocks[k-1]<j) SNDputnull1ch(outfile,&snd[k-1],format);
	else putout1chdata(outfile,infile[k-1],&snd[k-1],format,k);
    bs=(SNDblocksize(&snd[0],format)/SNDchannels(&snd[0],format))*N;
    if(format!=E_AU && mb%2 && bs%2) fputc(0,outfile);
    return;
}

int maxblocks(int blocks[],int N)
{
    int j,mb;

    if(N<=0) return 0;
    mb=blocks[0];
    for(j=2;j<=N;j++) if(blocks[j-1]>mb) mb=blocks[j-1]; 
    return mb;
}

int getallheader(FILE *infile[],SNDheader *snd,int *maxblocks,int N)
{
    int j,format,ret,ch;
    int mask = CH_MAGIC|CH_FMCODE|CH_SMPLRATE|CH_BITPERSMPL;

    if((format=getSNDheader(infile[0],&snd[0]))<0 || format==E_UNKNOWN){
        fprintf(stderr,"get header error (%d:%d)\n",1,format);
        return -1;
    }
    if((*maxblocks=SNDblocks(&snd[0],format))<0) return -2;
    for(j=2;j<=N;j++){
	if((ret=getSNDheader(infile[j-1],&snd[j-1]))!=format){
	    fprintf(stderr,"get header error (%d:%d)\n",j,ret);
	    return -1;
	}
	if((ret=SNDchheaderMASK(&snd[0],&snd[j-1],format,mask))<0){
	    fprintf(stderr,"Headers are different type.\n");
	    return -4;
	}
	if((ret=SNDblocks(&snd[j-1],format))<0) return -2;
	else if(ret>*maxblocks) *maxblocks=ret;
	if((ch=SNDchannels(&snd[j-1],format))!=1 && ch<j){
	    fprintf(stderr,"Data (%d) does not have appropriate channel. (%d)\n",
		    j,ch);
	    return -3;
	}
    }
    return format;
}

void putout1chdata(FILE *outfile,FILE *infile,SNDheader *snd,int format,int ch)
{
    int j,ch0=SNDchannels(snd,format);

    if(ch0==1) SNDreadput1chdata(infile,outfile,snd,format);
    else{
	for(j=1;j<=ch0;j++)
	  if(j!=ch) SNDskip1chdata(infile,snd,format);
	  else SNDreadput1chdata(infile,outfile,snd,format);
    }
    return;
}

int getarg(int argc,char *argv[],FILE **outfile,FILE *file[])
{
    int j;

    if(--argc<1 ||!strcmp(*(++argv),"-h") ||!strcmp(*argv,"-h")) return 0;
    if(!strcmp(*argv,"-o")){ 
	if(--argc<1) return -1;
	if(*(*argv+=2)=='\0'){ if(--argc<1) return -2; else argv++; }
	if((*outfile=fopen(*argv,"w"))==NULL) return -3;
	argv++;
    }
    if(argc>Maxchannel) return -5;
    for(j=1;j<=argc;j++,argv++)
      if((file[j-1]=fopen(*argv,"r"))==NULL){
	  fprintf(stderr,"File [%s] open error.\n",*argv);
	  return -6;
      }
    return argc;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndstereo (-o [outf]) [file1] [file2] ([file3] ...)",
	"  -o [outf]: ϥեλ (default: ɸ)",
	"",
	" [1] [file1],[file2](,...)  channel ΥեȤƽ˥ƥ쥪",
	"     (¿ channel) ˹ʪϤ롣",
	" [2]  channel ե뤬Υ (ñ channel) եǤʤ",
	"     ֹ channel ǡѤ롣㤨",
	"       sndstereo file1 file2 file3 file4",
	"     ϡfile2 ʹߤϥΥǡǤʤ 2ch ܡ3ch ܡ4ch",
	"     ܤΥǡΤߤФƥΥǡȤ롣äơ⤷",
	"     file3  2ch ե롢file4  2or3 ch file ξϥ顼",
	"     ʤ롣", 
	" [3] ĹϰĹե˹碌롣", 
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
