/* ǡ substr (data format ưȽ)
 * 12/30 2003
 * shige
 * sndsubstr.c
 *
 * $Id: sndsubstr.c,v 1.3 2004-01-13 15:37:16+09 shige Exp $
 */
/* sndsubstr (-o file) [start pos] ([length]) ([file])
 */

#undef DEBUG1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

int main(int argc,char *argv[]);
int getarg(int argc,char **argv,int *start,int *length,FILE **infile,
           FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    int start,length,j,ch,bs;
    int ret,format;
    SNDheader snd;
    long int blocks;

    if((ret=getarg(argc,argv,&start,&length,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if(length==0) return 0;
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
        fprintf(stderr,"Error: In getSNDheader(). (%d)\n",format);
        return 1;
    }
    blocks=SNDblocks(&snd,format);
    if(start>blocks) return 0;
    if(length<0 || start+length>blocks) length=blocks-start;
    putSNDheaderBlocks(outfile,&snd,length,format);
    ch=SNDchannels(&snd,format);
    bs=SNDblocksize(&snd,format);
    for(j=1;j<=start*ch;j++) SNDskip1chdata(infile,&snd,format);
    for(j=1;j<=length*ch;j++) SNDreadput1chdata(infile,outfile,&snd,format);
    if(format!=E_AU && bs%2 && length%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,int *start,int *length,FILE **infile,
	   FILE **outfile)
{
    *infile=stdin;
    *outfile=stdout;
    *length=-1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3; /* ٳ */
                if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
                if(strcmp(*argv,"-") && (*outfile=fopen(*argv,"w"))==NULL){
                    fprintf(stderr,"File [%s] open error.\n",*argv);
                    return -5;
                }
                break;
            case '\0': return -1;
            default: return -6;
            }
	}
	else break;
    }
    if(argc<2 || argc>3 || !isdigit(**argv)) return -10;
    if((*start=atoi(*argv))<0 ||(*start==0 && strcmp(*argv,"0"))) return -11;
    if(--argc==2){
	if(!isdigit(**(++argv)) || (*length=atoi(*argv))<=0) return -13;
    }
    if(strcmp(*(++argv),"-") && (*infile=fopen(*argv,"r"))==NULL) return -14;
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndsubstr (-o [outfile]) [start] ([length]) [infile]",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [start] : ϰ",
	"   [length]: ϺĹ (default: Ǹޤ)",
	"   [infile]: ϥե",
	" ",
	" [1] /ϥե '-' ꤷɸ/Ϥˤʤ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
